# Class MeshRenderer

java.lang.Object
org.jmol.render.ShapeRenderer
org.jmol.render.MeshRenderer

Direct Known Subclasses:
  `BioMeshRenderer, DrawRenderer, IsosurfaceRenderer`

public abstract class MeshRenderer extends ShapeRenderer
an abstract class subclasssed by BioShapeRenderer, DrawRenderer, and IsosurfaceRenderer

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`allowDashed`
`protected boolean`
`antialias`
`protected BS`
`bsPolygons`
`protected BS`
`bsPolygonsToExport`
`protected int`
`diameter`
`protected int`
`exportPass`
`protected boolean`
`forceShowTriangles`
`protected boolean`
`frontOnly`
`protected boolean`
`haveBsDisplay`
`protected float`
`imageFontScaling`
`protected boolean`
`isGhostPass`
`protected boolean`
`isShell`
`protected boolean`
`isTranslucent`
`protected boolean`
`isTranslucentInherit`
`protected P3`
`latticeOffset`
`protected Mesh`
`mesh`
`protected int`
`meshSlabValue`
`protected boolean`
`needTranslucent`
`protected short[]`
`normixes`
`protected P3[]`
`p3Screens`
`protected final P3`
`pt1f`
`protected P3i`
`pt1i`
`protected final P3`
`pt2f`
`protected P3i`
`pt2i`
`protected final P3i`
`pt3i`
`protected boolean`
`renderLow`
`protected float`
`scalePixelsPerMicron`
`protected P3i[]`
`screens`
`protected boolean`
`selectedPolyOnly`
`protected P4`
`thePlane`
`protected V3[]`
`transformedVectors`
`protected int`
`vertexCount`
`protected T3[]`
`vertices`
`protected boolean`
`volumeRender`
`protected float`
`width`

### Fields inherited from class ShapeRenderer

`colix, exportType, flags, g3d, isExport, mad, ms, myVisibilityFlag, shape, shapeID, tm, vwr`

## Constructor Summary

Constructors
Constructor
Description
`MeshRenderer()`

## Method Summary

Modifier and Type
Method
Description
`protected int`
`checkFront(short nA, short nB, short nC)`
`protected void`
`drawEdge(int iA, int iB, boolean fill, T3 vA, T3 vB, P3i sA, P3i sB)`
`protected void`
`drawTriangle(P3i screenA, short colixA, P3i screenB, short colixB, P3i screenC, short colixC, int check, int diam)`
`protected void`
`exportSurface(short colix)`
`protected boolean`
`isPolygonDisplayable(int i)`
`protected boolean`
`isVisibleNormix(short normix)`
`protected void`
`render2(boolean generateSet)`
Overridden in DrawRenderer and IsosurfaceRenderer
`protected void`
`render2b(boolean generateSet)`
`protected boolean`
`renderMesh2(Mesh mesh)`
overridden in BioShapeRenderer, DrawRenderer, and IsosurfaceRenderer
`protected void`
`renderPoints()`
`protected void`
`renderTriangles(boolean fill, boolean iShowTriangles, boolean generateSet)`
`boolean`
`setColix(short colix)`

### Methods inherited from class ShapeRenderer

`initRenderer, isVisibleForMe, render, renderShape, setup, setViewerG3dShapeID`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### mesh

protected Mesh mesh

### vertices

protected T3[] vertices

### normixes

protected short[] normixes

### screens

protected P3i[] screens

### p3Screens

protected P3[] p3Screens

### transformedVectors

protected V3[] transformedVectors

### vertexCount

protected int vertexCount

### imageFontScaling

protected float imageFontScaling

### scalePixelsPerMicron

protected float scalePixelsPerMicron

### diameter

protected int diameter

### width

protected float width

### allowDashed

protected boolean allowDashed

### isTranslucent

protected boolean isTranslucent

### frontOnly

protected boolean frontOnly

### isShell

protected boolean isShell

### antialias

protected boolean antialias

### haveBsDisplay

protected boolean haveBsDisplay

### selectedPolyOnly

protected boolean selectedPolyOnly

### isGhostPass

protected boolean isGhostPass

### thePlane

protected P4 thePlane

### latticeOffset

protected P3 latticeOffset

### pt1f

protected final P3 pt1f

### pt2f

protected final P3 pt2f

### pt1i

protected P3i pt1i

### pt2i

protected P3i pt2i

### pt3i

protected final P3i pt3i

### exportPass

protected int exportPass

### needTranslucent

protected boolean needTranslucent

### volumeRender

protected boolean volumeRender

### bsPolygons

protected BS bsPolygons

### isTranslucentInherit

protected boolean isTranslucentInherit

### renderLow

protected boolean renderLow

### meshSlabValue

protected int meshSlabValue

### forceShowTriangles

protected boolean forceShowTriangles

### bsPolygonsToExport

protected BS bsPolygonsToExport

## Constructor Details

### MeshRenderer

public MeshRenderer()

## Method Details

### renderMesh2

protected boolean renderMesh2(Mesh mesh)
overridden in BioShapeRenderer, DrawRenderer, and IsosurfaceRenderer

Parameters:
  `mesh` -
Returns:
  whether we need to show info

### setColix

public boolean setColix(short colix)

### isPolygonDisplayable

protected boolean isPolygonDisplayable(int i)

Parameters:
  `i` -
Returns:
  T/F

### render2

protected void render2(boolean generateSet)
Overridden in DrawRenderer and IsosurfaceRenderer

Parameters:
  `generateSet` -

### render2b

protected void render2b(boolean generateSet)

### renderPoints

protected void renderPoints()

### renderTriangles

protected void renderTriangles(boolean fill, boolean iShowTriangles, boolean generateSet)

### isVisibleNormix

protected boolean isVisibleNormix(short normix)

### drawTriangle

protected void drawTriangle(P3i screenA, short colixA, P3i screenB, short colixB, P3i screenC, short colixC, int check, int diam)

### checkFront

protected int checkFront(short nA, short nB, short nC)

### drawEdge

protected void drawEdge(int iA, int iB, boolean fill, T3 vA, T3 vB, P3i sA, P3i sB)

### exportSurface

protected void exportSurface(short colix)